#include"curs.h"
#include<iostream.h>

BMP::BMP(char* name)
{
  FILE *File;
  RGBQuad* RGBQ=NULL;
  BMPFileHeader *Hdr=0;
  BMPInfo *Inf=0;

  if((File=fopen(name,"r"))==NULL) error("Can't open file.\n");

  if(!(Hdr=(BMPFileHeader*)malloc(sizeof(BMPFileHeader)))||
     !(Inf=(BMPInfo*)malloc(sizeof(BMPInfo))))
  {
    fclose(File);
    error("No memory1.\n");
  }

  fread(Hdr,sizeof(BMPFileHeader),1,File);
  if(Hdr->Type!=19778)
  {
    fclose(File);
    error("Not BMP file.\n");
  }

  fread(Inf,sizeof(BMPInfo),1,File);

  Info.bpp=Inf->BitCount;
  Info.x=Inf->Width;
  Info.y=Inf->Height;
  Info.numColors=Inf->ClrUsed;

  if(Inf->ClrUsed==0) Info.numColors=256;

  free(Inf);

  if(!(RGBQ=(RGBQuad*)malloc(sizeof(RGBQuad)*Info.numColors))||
     !(Palette=(RGB*)malloc(sizeof(RGB)*Info.numColors)))
  {
    free(Hdr);
    fclose(File);
    error("No memory2.\n");
  }
  fread(RGBQ,Info.numColors*4,1,File);

  for(int i=0;i<Info.numColors;i++)
  {
    Palette[i].Red=RGBQ[i].Red>>2;
    Palette[i].Green=RGBQ[i].Green>>2;
    Palette[i].Blue=RGBQ[i].Blue>>2;
  }
  free(RGBQ);

  WORD ImgSize=Hdr->Size-Hdr->ImgOff;
  if(!(Img=(char *)malloc(ImgSize)))
  {
    fclose(File);
    error("No memory3.\n");
  }
  fseek(File,Hdr->ImgOff,SEEK_SET);
  fread(Img,ImgSize,1,File);
  free(Hdr);

  fclose(File);
}

BMP::~BMP()
{
  if(Palette!=0) free(Palette);
  if(Img!=0) free(Img);
}

void BMP::InstallPal()
{
  RegPal(Palette,Info.numColors);
}